// event definition - dd[i] = event buffer
// Z() -Z on Crate
// out(N); put number N in the event buffer (N == 16 bits)
// naf(N,A,F): Data for R/W is in CA.W (=CA.B[2]) CAMAC REGISTER (R/W)
// pat(N,A,F): naf + data to PAT.W (=PAT.B[2])
// rout(N,A,F) = read + move data to dd[nn++]
// nafd(N,A,F) = dataless NAF
//

void flush_event(void);

unsigned char NN1, NN2, SEC, NP;

#define FX2_CAM128 //Select the 4-module Box
//#define FX2_ISA  //Select the ISA-USB interface
#define NBFIF 160 // Event Fifo size. Max 200 (bytes) by now

void init_camac(void)
{
      unsigned char A,i;

      Z();
      NN1=3; //ADC
      NN2=4; //TDC
      naf(NN1,0,9); //A=0, F=9 clear module 4
      naf(NN2,0,9); //A=0, F=9 clear module 3

      CA.W=128; //ULD
      A=0;
      for(i=0;i<8;i++){ naf(NN1,A,17); naf(NN2,A,17); A++; }

      CA.W=120; //LLD
      A=8;
      for(i=0;i<8;i++){ naf(NN1,A,17); naf(NN2,A,17); A++;}

      CA.W=130; //OFFSET
      A=0;
      for(i=0;i<8;i++){ naf(NN1,A,20); naf(NN2,A,20); A++;}

      CA.W=120; //COMMON THRESHOLD
      naf(NN1,9,20); // A=9, F=20
      naf(NN2,9,20); // A=9, F=20

      CA.W=0x4a00;  //LAM Enable
      naf(NN1,14,20); // A=14, F=20

      CA.W=0x0a00;  //
      naf(NN2,14,20); // A=14, F=20
}

void event(void)
{
    pat(NN1,15,0);
    SEC=0;
    NP=0;
    if(PAT.W!=0)
     {
     if((PAT.W&1)!=0){
       SEC=1;
       out(0x8001);
       rout(NN1,0,0); //read P1 and send to event buffer (A=0, F=0)
       rout(NN2,0,0); //read P2 and send to event buffer (A=0, F=0)
       NP++;
       }

    if((PAT.B[0]&2)!=0){
      if(SEC==0){
       out(0x8003);
       }
       SEC=1;
       rout(NN1,1,0); //read P3 and send to event buffer (A=1, F=0)
       rout(NN2,1,0); //read P4 and send to event buffer (A=1, F=0)
       NP++;
      } else SEC=0;
    if((PAT.B[0]&4)!=0){
      if(SEC==0){
       out(0x8005);
       }
       SEC=1;
       rout(NN1,2,0); //read P5 and send to event buffer (A=2, F=0)
       rout(NN2,2,0); //read P6 and send to event buffer (A=2, F=0)
       NP++;
      } else SEC=0;
    if((PAT.B[0]&8)!=0){
      if(SEC==0){
       out(0x8007);
       }
       SEC=1;
       rout(NN1,3,0); //read P7 and send to event buffer (A=3, F=0)
       rout(NN2,3,0); //read P8 and send to event buffer (A=3, F=0)
       NP++;
      } else SEC=0;
    if((PAT.B[0]&0x10)!=0){
      if(SEC==0){
       out(0x8009);
       }
       SEC=1;
       rout(NN1,4,0); //read P9 and send to event buffer (A=4, F=0)
       rout(NN2,4,0); //read P10 and send to event buffer (A=4, F=0)
       NP++;
      } else SEC=0;

    if((PAT.B[0]&0x20)!=0){
      if(SEC==0){
       out(0x800b);
       }
       SEC=1;
       rout(NN1,5,0); //read P11 and send to event buffer (A=5, F=0)
       rout(NN2,5,0); //read P12 and send to event buffer (A=5, F=0)
       NP++;
      } else SEC=0;

    if((PAT.B[0]&0x40)!=0){
      if(SEC==0){
       out(0x800d);
       }
       SEC=1;
       rout(NN1,6,0); //read P13 and send to event buffer (A=6, F=0)
       rout(NN2,6,0); //read P14 and send to event buffer (A=6, F=0)
       NP++;
      } else SEC=0;

    if((PAT.B[0]&0x80)!=0){
      if(SEC==0){
       out(0x800f);
       }
       SEC=1;
       rout(NN1,7,0); //read P7 and send to event buffer (A=6, F=0)
       rout(NN2,7,0); //read P7 and send to event buffer (A=6, F=0)
       NP++;
      } else SEC=0;

       out(0xffff); //end event
     }
    nafd(NN1,0,9);//A=0, F=9 - clear module
    nafd(NN2,0,9);//A=0, F=9 - clear module
    flush_event();
}

void flush_event(){
    unsigned char i;
    for(i=0;i<nn;i++) *dest++=dd[i];
    len=len+nn;
    nn=0;
    if(len>NBFIF){
    *dest0=len;
    *(dest0+1)=0;
    SYNCDELAY;  EP6BCH=0;
    SYNCDELAY;  EP6BCL=len+2;
    SYNCDELAY;
    dest=EP6FIFOBUF+2;
    dest0=EP6FIFOBUF;
    len=0;
    }
}
